#define  _CRT_SECURE_NO_WARNINGS
#define  _USE_MATH_DEFINES
#include <math.h>
#include "Floats.h"
#include "Matrix.h"

///////////////////////////////////////////////////////////////////////////////	
void matrix::MakeProjectionMatrix(float FOV, float Aspect, float NearPlane, float FarPlane)
{
 float cot_fov = 1.0f / tanf(FOV*((float)M_PI/360.0f));
 
 float fcx = cot_fov / Aspect;
 float fcy = cot_fov;
 float a   = FarPlane / (NearPlane-FarPlane);
 float b   = NearPlane*FarPlane/(NearPlane-FarPlane);

 #define M(col, row) m.v[(col<<2)+row]

 M(0,0) = fcx;  M(0,1) = 0.0f; M(0,2) = 0; M(0,3) = 0.0f;
 M(1,0) = 0.0f; M(1,1) = fcy;  M(1,2) = 0; M(1,3) = 0.0f;
 M(2,0) = 0.0f; M(2,1) = 0.0f; M(2,2) = a; M(2,3) =-1.0f;
 M(3,0) = 0.0f; M(3,1) = 0.0f; M(3,2) = b; M(3,3) = 0.0f;

 #undef M

 return;
}
///////////////////////////////////////////////////////////////////////////////	
void matrix::MakeLookAtMatrix(float eyex,    float eyey,    float eyez,
		                      float centerx, float centery, float centerz,
						      float upx,     float upy,     float upz)
{
 float3 Eye = float3(eyex,    eyey,    eyez);
 float3 At  = float3(centerx, centery, centerz);
 float3 Up  = float3(upx,     upy,     upz);

 float3 ZAxis = normalize(Eye - At);
 float3 XAxis = normalize(cross(Up, ZAxis));
 float3 YAxis = cross(ZAxis, XAxis);

 Identity();

 m.v[ 0] = XAxis.x;         m.v[ 1] = YAxis.x;         m.v[ 2] = ZAxis.x;
 m.v[ 4] = XAxis.y;         m.v[ 5] = YAxis.y;         m.v[ 6] = ZAxis.y;
 m.v[ 8] = XAxis.z;         m.v[ 9] = YAxis.z;         m.v[10] = ZAxis.z;
 m.v[12] =-dot(XAxis, Eye);	m.v[13] =-dot(YAxis, Eye); m.v[14] =-dot(ZAxis, Eye);

 return;
}
///////////////////////////////////////////////////////////////////////////////	
